/*
 * @author Johannes Loinig, member of the ISAC-team, 
 * Copyright (c) 2005 by Johannes Loinig
 * created Jul 26, 2005 10:59:01 AM
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 * 
 * Use is subject to PGPL license terms.
 */
package isac.browserdialog;

import isac.bridge.CalcTree;
import isac.bridge.MathEngine;
import isac.interfaces.IToCalc;
import isac.kestore.KEStoreServices;
import isac.session.SessionManager;
import isac.useractions.ActionOnUIElement;
import isac.useractions.IUIElement;
import isac.useractions.UserActionOnKEStoreID;
import isac.util.Formalization;
import isac.util.formulae.Match;
import isac.util.formulae.ProblemID;
import isac.util.parser.FormalizationDigest;
import isac.wsdialog.IWorksheetDialog;

import java.util.Vector;

import junit.framework.TestCase;

/**
 * @author Johannes Loinig
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class TestProblemBrowserDialog extends TestCase {

    private Formalization formalization_;

    private MathEngine math_engine_;

    private ProblemBrowserDialog problem_browser_dialog_;

    private SessionManager session_manager_;

    private String session_id_;

    protected void setUp() throws Exception {
        super.setUp();
        //load the file of the example,
        //see TestKEStoreServices#testLoadContentMinisubpbl
        KEStoreServices ks = new KEStoreServices("isac/xmldata");
        Vector vec = ks.loadContent("exp", "exp_IsacCore_Tests_7a.xml");
        //parse out the Formalization
        //see TestFormalizationDigest#testParseExplMini
        String xmlstr = (String) vec.firstElement();
        FormalizationDigest fd = new FormalizationDigest();
        formalization_ = fd.parseFormalization((String) xmlstr);

        MathEngine.init("localhost");
        math_engine_ = MathEngine.getMathEngine();

        session_manager_ = SessionManager.getInstance();
        session_id_ = (String) session_manager_.login("x", "x").elementAt(0);
        problem_browser_dialog_ = (ProblemBrowserDialog) session_manager_
                .getProblemBrowserDialog(session_id_);

        MockBrowserFrame mock_browser_frame = new MockBrowserFrame();
        problem_browser_dialog_.registerBrowserFrame(mock_browser_frame);

        String wsd_id = session_manager_.openWorksheetDialog(session_id_);
        IWorksheetDialog wsd = session_manager_.getWorksheetDialog(wsd_id);
        
        //see isac.bridge.TestSpecify#testMatchRefine
        CalcTree ct = wsd.getCalcTree(0, formalization_, IWorksheetDialog.STARTFROM_EXAMPLE);
        ct.startCalculate();
        ct.autoCalculate(IToCalc.SCOPE_CALCULATION, 1);
        ct.autoCalculate(IToCalc.SCOPE_CALCULATION, 1);
    }

    public void testMatchRefine() throws Exception {
        ProblemID id = new ProblemID();
        id.addString("e_pblID");
        UserActionOnKEStoreID user_action = new UserActionOnKEStoreID(
                IUIElement.UI_PROBLEMBROWSER_SELECTION_CHANGED, id);
        problem_browser_dialog_.notifyUserAction(user_action);

    }
}