/*
 * @author Walther Neuper, member of the ISAC-team, 
 * Copyright (c) 2005 by Walther Neuper 
 * created Apr 13, 2005 3:45:36 PM
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 * 
 * Use is subject to PGPL license terms.
 */
package isac.session;

import java.rmi.RemoteException;
import java.util.Vector;
import junit.framework.TestCase;

import isac.util.InformationProcessor;
import isac.util.users.IUserSettings;
import isac.util.users.User;
import isac.wsdialog.WorksheetDialog;

/**
 * @author neuper
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class TestSessionDialog extends TestCase {

	/**
	 * trace the login down to the SessionManager
	 * 
	 * @exception RemoteException
	 *                if SessionManager=ObjectManager NOT launched (ObjectManager
	 *                launchedd after KEStore, BridgeMain)
	 * @see isac.util.user.TestUser#testGetUserSettings
	 */
	public void testLogin() {
		System.out.println("---BEGIN isac.kestore.TestSessionDialog#testLogin");


		// see isac.gui.WindowApplication#login
		String sessionId = InformationProcessor.login("x", "x");
		//...ie. InformationProcessor is on same virtual machine !???!!!
		assertEquals("sessionID from InformationProcessor.login", sessionId,
				"x0");
		ISessionManager sdialog = InformationProcessor.getSDialog();

		// see isac.util.InformationProcessor#login
		Vector sessionIds = new Vector();
		try {
			sessionIds = sdialog.login("x", "x");
		} catch (RemoteException e) {
			//...ie. SessionManager is on other virtual machine !???!!!
			// Vector userV = SessionManager.login("x","x");
			// causes error 'this method is not static'
			e.printStackTrace();
		}
		sessionId = (String) sessionIds.elementAt(0);
		assertEquals("sessionID from SessionManager.login", sessionId, "x0");

		// see isac.wsdialog.WorksheetDialog#constructor
		User user = null;
		try {
			user = sdialog.getUser(sessionId);
		} catch (RemoteException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		String usern = user.getUsername();
		assertEquals("username", usern, "x");

		System.out.println("---END isac.kestore.TestSessionDialog#testLogin");
	}

}