/****************************************************************** 
 * @author Alois Kirchsteiger member of the isac team
 * Copyright (c) 2004 by Alois Kirchsteiger
 * create 31.08.2004, 11:46:39
 * Insitute for Softwaretechnology, Graz University of Technology, Austria. 
 * 
 * Use is subject to license terms.
 ******************************************************************/

package isac.gui.browser;

import isac.gui.browser.panels.TabPanel;
import isac.useractions.IUIAction;

import java.awt.Dimension;
import java.io.Serializable;

import javax.swing.*;

/**
 * @author Alois Kirchsteiger, JL
 */
public class BrowserWindow extends JPanel {

    protected TabPanel tab_panel_;

    protected JSplitPane split_pane_;

    //TODO: temporary solution, will be changed to HTMLEditorKit
    protected JDesktopPane desktop_pane_;

    public BrowserWindow(TabPanel tabPanel) {
        this.tab_panel_ = tabPanel;
        buildSplitPane();
        this.setVisible(true);
    }

    public void setTabPanel(TabPanel tabPanel) {
        this.tab_panel_ = tabPanel;
    }

    public TabPanel getTabPanel() {
        return this.tab_panel_;
    }

    private void buildSplitPane() {
        this.split_pane_ = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, false);
        tab_panel_.setMinimumSize(new Dimension(250, 600));
        tab_panel_.setPreferredSize(new Dimension(250, 600));
        split_pane_.setLeftComponent(new JScrollPane(tab_panel_));
        desktop_pane_ = new JDesktopPane();
        desktop_pane_.setMinimumSize(new Dimension(50, 600));
        split_pane_.setRightComponent(desktop_pane_);
        split_pane_.setOneTouchExpandable(true);
        split_pane_.setDividerLocation(-1);
        this.add(split_pane_);
    }

	/* (non-Javadoc)
	 * @see isac.gui.IToWorksheetUser#addToMenuBar(isac.wsdialog.IUIAction)
	 */
	public void addToMenuBar(IUIAction action) {
		// TODO Auto-generated method stub
		
	}

}