/****************************************************************** 
 * Copyright (c) 2003, Mario Hochreiter, Student of 
 * Software Engineering at FH-Hagenberg, Austria. 
 * Project member of the isac team at the Institute for 
 * Software-Technologie, Graz University of Technology, Austria. 
 * 
 * Use is subject to license terms.
 ******************************************************************/

package isac.gui.browser.panels;

import isac.gui.WindowApplication;
import isac.gui.browser.BrowserTreeModel;
import isac.gui.util.Hierarchy;
import isac.interfaces.IGuiToGui;
import isac.interfaces.IToGUI;

import java.awt.BorderLayout;
import java.awt.event.MouseListener;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JTree;
import javax.swing.tree.TreeModel;
import javax.swing.tree.TreePath;
import javax.swing.tree.TreeSelectionModel;

/**
 * @author Mario Hochreiter, JL
 * @version 1.0
 *  
 */
public abstract class TabPanel extends JPanel implements IToGUI {

    protected JTree view_tree_;

    /** Handles double clicks on a tree node */
    protected MouseListener ml_;

    /** The mother Frame */
    protected WindowApplication root_;
    
    protected IGuiToGui ui_interface_;

    public TabPanel(JFrame root, Hierarchy hierarchy) {
        this.root_ = (WindowApplication) root;
        TreeModel model = new BrowserTreeModel(hierarchy);
        //    this.initMouseListener();
        this.initTree(model);
        this.setLayout(new BorderLayout());
        this.add(view_tree_, BorderLayout.CENTER);
    }

    private void initTree(TreeModel model) {
        view_tree_ = new JTree(model);
        view_tree_.getSelectionModel().setSelectionMode(
                TreeSelectionModel.SINGLE_TREE_SELECTION);
    }
    
    /**
     * To set the interface to the gui root object
     * 
     * @param ui_interface the root Object
     */
    public void setBrowserInterface(IGuiToGui ui_interface) {
    	ui_interface_ = ui_interface;
    }
    
/*
 * to set a specified element in the tree
 * 
 * @author JL
 * @param path the Path to the element to select
 */
    public void setSelectionPath(TreePath path) {
    	view_tree_.setSelectionPath(path);
    }
}