/*
 * Created on Feb 6, 2004
 */
package isac.useractions;

import isac.interfaces.ICalcElement;

/**
 * Describes a user action (i.e. direction gui --> dialog) which has to pass a
 * CalcElement, e.g a newly entered formula or tactic which is not yet part of
 * the calculation tree.
 * 
 * @see isac.useractions.UserActionOnIterator
 * @see isac.useractions.UserActionOnKEStoreID
 * @author Alan Krempler
 */
public class UserActionOnCalcElement extends UserAction {
    private ICalcElement calc_element_;

    public UserActionOnCalcElement(int id, ICalcElement calc_element) {
        super(id);
        calc_element_ = calc_element;
    }

    public ICalcElement getCalcElement() {
        return calc_element_;
    }

}