/*
 * Created on Dec 12, 2003
 */
package isac.useractions;

import isac.util.formulae.KEStoreID;

/**
 * Describes an user action on part of a CalcHead.
 * 
 * @see isac.useractions.UserActionOnIterator
 * @see isac.useractions.UserActionOnKEStoreID
 * @author Alan Krempler
 */
public class UserActionOnKEStoreID extends UserAction {
    private KEStoreID chc_id_;

    /**
     * @version 1.0
     * @param id
     *            IUIElement identifying the action
     * @param chc_id
     *            the data accompanied with this action
     */
    public UserActionOnKEStoreID(int id, KEStoreID chc_id) {
        super(id);
        chc_id_ = chc_id;
    }

    public KEStoreID getObjectID() {
        return chc_id_;
    }

}